import React from "react";
import { MdOutlineSave } from "react-icons/md";
import { useEffect, useState } from "react";

const FileInput = ({ fileAdd, file, setFile, setText, text, newDiff }) => {
  const [save, setSave] = useState(true);
  const [diff, setDiff] = useState(false);
  useEffect(() => {
    getText(file);
  }, [file]);

  function getEnding(file:File) {
    var splited = file.name.split(".");
    return splited[splited.length - 1];
  }

  const handleFileSubmit = () => {
    if (file == null) {
      return;
    }
    var ending = getEnding(file);
    var xml = false;
    switch (ending) {
      case "xml":
        xml = true;
        break;
      case "jsgf":
        xml = false;
        break;
      default:
        alert("unknown file type");
        return;
    }
    fileAdd(text, xml, save, diff);
  };
  const changeFileInput = (e) => {
    setFile(e.target.files[0]);
  };
  const getText = async (fil:File) => {
    if (fil === null || file.name === null) {
      setText("");
      return;
    }

    var ending = getEnding(fil);
    if (!(ending === "jsgf" || ending === "xml")) {
      setText("invalid file type");
      return;
    }
    var textPro = await fil.text();
    setText(textPro);
  };
  return (
    <form onSubmit={handleFileSubmit} className="fileInput">
      <p>
        <input
          type="checkbox"
          defaultChecked={save}
          onClick={() => setSave(!save)}
          id="save"
        />
        <label htmlFor="save" className="smallText">
          save
        </label>{" "}
        {newDiff && (
          <>
            <input
              type="checkbox"
              defaultChecked={diff}
              onClick={() => setDiff(!diff)}
              id="newDiff"
            />
            <label htmlFor="newDiff" className="smallText">
              add new grammar on diff
            </label>{" "}
          </>
        )}
        <input type="file" onChange={changeFileInput} />
        <MdOutlineSave onClick={handleFileSubmit} />
      </p>
      <textarea
        className="transparent big"
        onChange={(e) => setText(e.target.value)}
        rows={15}
        cols={15}
        value={text}
      />
    </form>
  );
};

export default FileInput;
