import React from "react";
import { useState } from "react";
import {
  MdDownload,
  MdExpandLess,
  MdExpandMore,
  MdRefresh,
  MdOutlineDelete,
} from "react-icons/md";
export function FileOneView({ file, getFile, deleteFile ,grammar}) {
  const [more, setMore] = useState(true);
  return (
    <div className="cell" key={file.id}>
      <table>
        <thead>
          <tr>
            <th>Generated</th>
            <th>Xml</th>
            <th>Size</th>
            <th>
              <MdRefresh onClick={() => getFile(file.id, grammar.id)} />
            </th>
            <th rowSpan={2}>
              <a
                href={
                  //test production difference
                  (window.location.hostname === "localhost"
                    ? "http://localhost:8080"
                    : "") +
                  "/api/files/" +
                  +file.id +
                  "/download"
                }
              >
                <MdDownload />
              </a>
            </th>
            <th rowSpan={2}>
              <MdOutlineDelete
                onClick={() => deleteFile(file.id, grammar.id)}
              />
            </th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>{file.generated ? "✓" : "❌"}</td>
            <td>{file.xml ? "✓" : "❌"}</td>
            <td>{file.size + " B"}</td>
            <td>
              {" "}
              {more ? (
                <MdExpandLess onClick={() => setMore(!more)} />
              ) : (
                <MdExpandMore onClick={() => setMore(!more)} />
              )}
            </td>
          </tr>
          <tr>
            <td colSpan={5}>
              {file.content && more && (
                <textarea
                  className="transparent big"
                  readOnly={true}
                  rows={15}
                  cols={50}
                  value={file.content}
                />
              )}
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  );
}
