import { FileOneView } from "./FileOneView.tsx";
import React, { useState } from "react";
import {
  MdDownload,
  MdExpandLess,
  MdExpandMore,
  MdOutlineDelete,
} from "react-icons/md";

import FileInput from "./FileInput.tsx";
export function FileView({
  generateFile,
  grammar,
  getFile,
  fileToGrammar,
  deleteFile,
  deleteFilesFromGrammar,
}) {
  const [xml, setXml] = useState(false);
  const [more, setMore] = useState(false);
  const [fileInput, setFileInput] = useState(false);
  const [file, setFile] = useState({});
  const [text, setText] = useState("");
  const fileAdd = (file, xml, save, diff) => {
    fileToGrammar(file, xml, grammar.id, save, diff);
  };
  return (
    <>
      <p>
        <button onClick={() => setXml(!xml)}>{xml ? "JSGF" : "XML"}</button>{" "}
        <button onClick={() => generateFile(xml, grammar.id)}>
          GENERATE {xml ? "XML" : "JSGF"}{" "}
        </button>{" "}
        <a
          href={
            (window.location.hostname === "localhost"
              ? "http://localhost:8080"
              : "") +
            "/api/files/" +
            grammar.id +
            "/new/" +
            (xml ? "xml" : "jsgf") +
            "/download"
          }
        >
          <MdDownload />
        </a>{" "}
      </p>
      {(xml ? grammar.xmlGen : grammar.jsgfGen) && (
        <p>
          <textarea
            className="transparent big"
            readOnly={true}
            rows={15}
            cols={50}
            value={xml ? grammar.xmlGen : grammar.jsgfGen}
          />
        </p>
      )}
      <button onClick={() => setFileInput(!fileInput)}>
        {fileInput ? "CANCEL" : "ADD FILE"}
      </button>
      {"  "}
      {fileInput && (
        <FileInput
          fileAdd={fileAdd}
          file={file}
          setFile={setFile}
          setText={setText}
          text={text}
          newDiff={true}
        />
      )}
      <div className="cell">{grammar.files.length + " files"}</div>
      <MdOutlineDelete onClick={() => deleteFilesFromGrammar(grammar.id)} />
      {more ? (
        <MdExpandLess onClick={() => setMore(!more)} />
      ) : (
        <MdExpandMore onClick={() => setMore(!more)} />
      )}

      {more && (
        <div className="table">
          {grammar.files.map((file) => (
            <FileOneView
              file={file}
              getFile={getFile}
              deleteFile={deleteFile}
              grammar={grammar}
            />
          ))}
        </div>
      )}
    </>
  );
}
