import { MdEdit, MdOutlineSave, MdOutlineDelete } from "react-icons/md";
import { useState } from "react";
import { GiTreeRoots } from "react-icons/gi";
import React from "react";
import { RightSide } from "../App";
const RuleView = ({ rule, deleteRule, changeRule, masterRoot, changeRoot }) => {
  const [edit, setEdit] = useState(false);
  const [leftSymbol, setLeftSymbol] = useState("");
  const [rightSide, setRightSide] = useState("");
  const handlesaveRule = (e) => {
    e.preventDefault();
    changeRule(rule.id, {
      leftSymbol: leftSymbol,
      rightSide: [{ part: rightSide }],
    });
    setEdit(false);
  };
  

  const getStringRight = (rightSide:RightSide[]) => {
    let result = "";
    let i = 0;
    rightSide.forEach((element) => {
      result += element.part;
      if (i + 1 < rightSide.length) {
        result += " | ";
      }
      i++;
    });
    return result;
  };

  return (
    <div className={rule.root ? "root" : ""}>
      {((masterRoot && rule.root) || !masterRoot) && (
        <GiTreeRoots onClick={() => changeRoot(rule.id, rule)} />
      )}{" "}
      {rule.leftSymbol + " = " + getStringRight(rule.rightSide)}
      {"   "}
      <MdEdit onClick={() => setEdit(!edit)} />
      {"  "}
      <MdOutlineDelete onClick={() => deleteRule(rule.id, rule.root)} />
      {edit && (
        <form onSubmit={handlesaveRule}>
          <input
            className="ruleInput transparent"
            onChange={(e) => {
              setLeftSymbol(e.target.value);
            }}
            type="text"
            placeholder="Set left symbol"
          />
          =
          <input
            className="ruleInput transparent"
            onChange={(e) => {
              setRightSide(e.target.value);
            }}
            type="text"
            placeholder="Set right side"
          />{" "}
          <MdOutlineSave onClick={handlesaveRule} />
        </form>
      )}
    </div>
  );
};

export default RuleView;
